$colorSetColors = "";
schedule(1, 0, initializeColorSetColors);

package forceAvatarColorsToColorset {
    function GameConnection::applyBodyColors(%client) {
        if (!isObject(%client)) {
            return;
        }
        %client.chestColor = findClosestColor(%client.chestColor, $colorSetColors);
        %client.accentColor = findClosestColor(%client.accentColor, $colorSetColors);
        %client.hatColor = findClosestColor(%client.hatColor, $colorSetColors);
        %client.headColor = findClosestColor(%client.headColor, $colorSetColors);
        %client.packColor = findClosestColor(%client.packColor, $colorSetColors);
        %client.secondPackColor = findClosestColor(%client.secondPackColor, $colorSetColors);
        %client.hipColor = findClosestColor(%client.hipColor, $colorSetColors);
        %client.llegColor = findClosestColor(%client.llegColor, $colorSetColors);
        %client.rlegColor = findClosestColor(%client.rlegColor, $colorSetColors);
        %client.larmColor = findClosestColor(%client.larmColor, $colorSetColors);
        %client.rarmColor = findClosestColor(%client.rarmColor, $colorSetColors);
        %client.lhandColor = findClosestColor(%client.lhandColor, $colorSetColors);
        %client.rhandColor = findClosestColor(%client.rhandColor, $colorSetColors);
        return Parent::applyBodyColors(%client);
    }

    function serverCmdUpdateBodyColors(%client, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor, %LLegColor, %RLegColor, %LArmColor, %RArmColor, %LHandColor, %RHandColor, %decalName, %faceName) {
        if (!isObject(%client)) {
            return;
        }
        %chestColor = findClosestColor(%chestColor, $colorSetColors);
        %accentColor = findClosestColor(%accentColor, $colorSetColors);
        %hatColor = findClosestColor(%hatColor, $colorSetColors);
        %headColor = findClosestColor(%headColor, $colorSetColors);
        %packColor = findClosestColor(%packColor, $colorSetColors);
        %secondPackColor = findClosestColor(%secondPackColor, $colorSetColors);
        %hipColor = findClosestColor(%hipColor, $colorSetColors);
        %llegColor = findClosestColor(%llegColor, $colorSetColors);
        %rlegColor = findClosestColor(%rlegColor, $colorSetColors);
        %larmColor = findClosestColor(%larmColor, $colorSetColors);
        %rarmColor = findClosestColor(%rarmColor, $colorSetColors);
        %lhandColor = findClosestColor(%lhandColor, $colorSetColors);
        %rhandColor = findClosestColor(%rhandColor, $colorSetColors);

        return Parent::serverCmdUpdateBodyColors(%client, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor, %LLegColor, %RLegColor, %LArmColor, %RArmColor, %LHandColor, %RHandColor, %decalName, %faceName);
    }
};

function colorDistance(%color1, %color2) {
    %dist = arbitraryVectorLen(arbitraryVectorSub(%color1, %color2));
    %color1trans = getWord(%color1, 3);
    %color2trans = getWord(%color2, 3);
    if (%color1trans != %color2trans && (%color1trans == 1 || %color2trans == 1) || %color2trans == 0) {
        %dist = 9999;
    }
    return %dist;
}

function findClosestColor(%color, %otherColors) {
    %closestColor = "";
    %closestDist = 1000000;
    for (%i = 0; %i < getRecordCount(%otherColors); %i++) {
        %currentColor = getRecord(%otherColors, %i);
        if ((%currentDist = colorDistance(%color, %currentColor)) < %closestDist) {
            %closestColor = %currentColor;
            %closestDist = %currentDist;
        }
    }
    return %closestColor;
}

function initializeColorSetColors() {
    $colorSetColors = "";
    for (%i = 0; %i < 64; %i++) {
        if (!isObject("color"@ %i @"SprayCanImage")) {
            return;
        }
        if ($colorSetColors $= "") {
            $colorSetColors = getColorIDTable(%i);
        } else {
            $colorSetColors = $colorSetColors NL getColorIDTable(%i);
        }
    }
}

function arbitraryVectorSub(%v1, %v2) {
    %dimensions = (getWordCount(%v1) > getWordCount(%v2)) ? getWordCount(%v1) : getWordCount(%v2);
    %diff = getWord(%v1, 0) - getWord(%v2, 0);
    for (%i = 1; %i < getWordCount(%v1); %i++) {
        %diff = %diff SPC (getWord(%v1, %i) - getWord(%v2, %i));
    }
    return %diff;
}

function arbitraryVectorLen(%v) {
    for (%i = 0; %i < getWordCount(%v); %i++) {
        %sqrDist += mPow(getWord(%v, %i), 2);
    }
    return mSqrt(%sqrDist);
}

activatePackage(forceAvatarColorsToColorset);
